Unit ErrColl;

Interface

Uses Objects, ErrObj;

Type
	
	PECollection = ^TECollection;
	TECollection = Object(  TCollection )
	  _errstat : TEObject;

    Constructor Init( ALimit, ADelta: integer );
    Function GetLastErr: Word;
    Function GetLastCode: Word;
    Procedure Reset;
    Function Failed: Boolean;
    Procedure SetFields(err, info: Word);
    Procedure Error( Code, info: Integer ); virtual;
    Procedure ForwardError( Const anObj: TEObject );
		Function GetErrStat: PEObject;

    Constructor Load ( Var S: TStream );

	End;

	PESortedCollection = ^TESortedCollection;
	TESortedCollection = Object(  TSortedCollection )
	  _errstat : TEObject;

    Constructor Init( ALimit, ADelta: integer );
    Function GetLastErr: Word;
    Function GetLastCode: Word;
    Procedure Reset;
    Function Failed: Boolean;
    Procedure SetFields(err, info: Word);
    Procedure Error( Code, info: Integer ); virtual;
    Procedure ForwardError( Const anObj: TEObject );
		Function GetErrStat: PEObject;

    Constructor Load ( Var S: TStream );

	End;

	PEStrCollection = ^TEStrCollection;
  TEStrCollection = object(TStrCollection)
	  _errstat : TEObject;

    Constructor Init( ALimit, ADelta: integer );
    Function GetLastErr: Word;
    Function GetLastCode: Word;
    Procedure Reset;
    Function Failed: Boolean;
    Procedure SetFields(err, info: Word);
    Procedure Error( Code, info: Integer ); virtual;
    Procedure ForwardError( Const anObj: TEObject );
		Function GetErrStat: PEObject;

    Constructor Load ( Var S: TStream );
  end;

	PEUnsortedStrCollection = ^TEUnsortedStrCollection;
  TEUnsortedStrCollection = object(TECollection)
    procedure FreeItem(Item: Pointer); virtual;
    function GetItem(var S: TStream): Pointer; virtual;
    procedure PutItem(var S: TStream; Item: Pointer); virtual;
  end;


Procedure RegisterECollections;

Implementation

Uses Strings;

{+------------------------------------------------------------------
 | Methods of TECollection
 +------------------------------------------------------------------}
Constructor TECollection.Init( ALimit, ADelta: integer );
  Begin
	  inherited Init( ALimit, ADelta );
		_errStat.Init;
	End; { TECollection.Init }

Function TECollection.GetLastErr: Word;
  Begin
	  GetLastErr := _errStat.GetLastErr
	End; { TECollection.GetLastErr }

Function TECollection.GetLastCode: Word;
  Begin
	  GetLastCode := _errStat.GetLastCode
	End; { TECollection.GetLastCode }

Procedure TECollection.Reset;
  Begin
	  _errStat.Reset;
	End; { TECollection.Reset }

Function TECollection.Failed: Boolean;
  Begin
	  Failed := _errStat.Failed
	End; { TECollection.Failed }

Procedure TECollection.SetFields(err, info: Word);
  Begin
	  _errStat.SetFields(  err, info )
	End; { TECollection.SetFields }

Procedure TECollection.Error( Code, info: Integer );
  Begin
	  _errStat.Error(  Code, info );
	End; { TECollection.Error }

Procedure TECollection.ForwardError( Const anObj: TEObject );
  Begin
	  _errStat.ForwardError(  anObj );
	End; { TECollection.ForwardError }

Function TECollection.GetErrStat: PEObject;
  Begin
	  GetErrStat := @_errStat;
	End; { TECollection.GetErrStat }

Constructor TECollection.Load ( Var S: TStream );
  Begin
	  inherited Load( S );
		_errStat.Init;
	End; { TECollection.Load }

{+------------------------------------------------------------------
 | Methods of TESortedCollection
 +------------------------------------------------------------------}
Constructor TESortedCollection.Init( ALimit, ADelta: integer );
  Begin
	  inherited Init( ALimit, ADelta );
		_errStat.Init;
	End; { TESortedCollection.Init }

Function TESortedCollection.GetLastErr: Word;
  Begin
	  GetLastErr := _errStat.GetLastErr
	End; { TESortedCollection.GetLastErr }

Function TESortedCollection.GetLastCode: Word;
  Begin
	  GetLastCode := _errStat.GetLastCode
	End; { TESortedCollection.GetLastCode }

Procedure TESortedCollection.Reset;
  Begin
	  _errStat.Reset;
	End; { TESortedCollection.Reset }

Function TESortedCollection.Failed: Boolean;
  Begin
	  Failed := _errStat.Failed
	End; { TESortedCollection.Failed }

Procedure TESortedCollection.SetFields(err, info: Word);
  Begin
	  _errStat.SetFields(  err, info )
	End; { TESortedCollection.SetFields }

Procedure TESortedCollection.Error( Code, info: Integer );
  Begin
	  _errStat.Error(  Code, info );
	End; { TESortedCollection.Error }

Procedure TESortedCollection.ForwardError( Const anObj: TEObject );
  Begin
	  _errStat.ForwardError(  anObj );
	End; { TESortedCollection.ForwardError }

Function TESortedCollection.GetErrStat: PEObject;
  Begin
	  GetErrStat := @_errStat;
	End; { TESortedCollection.GetErrStat }

Constructor TESortedCollection.Load ( Var S: TStream );
  Begin
	  inherited Load( S );
		_errStat.Init;
	End; { TESortedCollection.Load }

{+------------------------------------------------------------------
 | Methods of TEStrCollection
 +------------------------------------------------------------------}
Constructor TEStrCollection.Init( ALimit, ADelta: integer );
  Begin
	  inherited Init( ALimit, ADelta );
		_errStat.Init;
	End; { TEStrCollection.Init }

Function TEStrCollection.GetLastErr: Word;
  Begin
	  GetLastErr := _errStat.GetLastErr
	End; { TEStrCollection.GetLastErr }

Function TEStrCollection.GetLastCode: Word;
  Begin
	  GetLastCode := _errStat.GetLastCode
	End; { TEStrCollection.GetLastCode }

Procedure TEStrCollection.Reset;
  Begin
	  _errStat.Reset;
	End; { TEStrCollection.Reset }

Function TEStrCollection.Failed: Boolean;
  Begin
	  Failed := _errStat.Failed
	End; { TEStrCollection.Failed }

Procedure TEStrCollection.SetFields(err, info: Word);
  Begin
	  _errStat.SetFields(  err, info )
	End; { TEStrCollection.SetFields }

Procedure TEStrCollection.Error( Code, info: Integer );
  Begin
	  _errStat.Error(  Code, info );
	End; { TEStrCollection.Error }

Procedure TEStrCollection.ForwardError( Const anObj: TEObject );
  Begin
	  _errStat.ForwardError(  anObj );
	End; { TEStrCollection.ForwardError }

Function TEStrCollection.GetErrStat: PEObject;
  Begin
	  GetErrStat := @_errStat;
	End; { TEStrCollection.GetErrStat }

Constructor TEStrCollection.Load ( Var S: TStream );
  Begin
	  inherited Load( S );
		_errStat.Init;
	End; { TEStrCollection.Load }
{+------------------------------------------------------------------
 | Methods of TEUnsortedStrCollection
 +------------------------------------------------------------------}
procedure TEUnsortedStrCollection.FreeItem(Item: Pointer);
begin
  StrDispose(Item);
end;

function TEUnsortedStrCollection.GetItem(var S: TStream): Pointer;
begin
  GetItem := S.StrRead;
end;

procedure TEUnsortedStrCollection.PutItem(var S: TStream; Item: Pointer);
begin
  S.StrWrite(Item);
end;

Const
  RECollection : TStreamRec= (
     ObjType : 1150;
     VmtLink : Ofs( TypeOf( TECollection )^);
     Load    : @TECollection.Load;
     Store   : @TECollection.Store );
  RESortedCollection : TStreamRec= (
     ObjType : 1151;
     VmtLink : Ofs( TypeOf( TESortedCollection )^);
     Load    : @TESortedCollection.Load;
     Store   : @TESortedCollection.Store );
  REStrCollection : TStreamRec= (
     ObjType : 1152;
     VmtLink : Ofs( TypeOf( TEStrCollection )^);
     Load    : @TEStrCollection.Load;
     Store   : @TEStrCollection.Store );
  REUnsortedStrCollection : TStreamRec= (
     ObjType : 1153;
     VmtLink : Ofs( TypeOf( TEUnsortedStrCollection )^);
     Load    : @TEUnsortedStrCollection.Load;
     Store   : @TEUnsortedStrCollection.Store );

Procedure RegisterECollections;
  Begin
	  RegisterType( RECollection );
	  RegisterType( RESortedCollection );
	  RegisterType( REStrCollection );
	  RegisterType( REUnsortedStrCollection );
  End;
End.
