Unit GrayDlgs;

Interface

Uses WinTypes, OWindows, ODialogs;

Type
  TGrayDialog = Object( TDialog )
    Procedure WMCtlColor( Var Msg: TMessage );
      virtual wm_first+wm_ctlcolor;
  end;
  TGrayDlgWindow = Object( TDlgWindow )
    Procedure WMCtlColor( Var Msg: TMessage );
      virtual wm_first+wm_ctlcolor;
  end;

Implementation

Uses WinProcs;

Procedure TGrayDialog.WMCtlColor( Var Msg: TMessage );
  Var
    aDC: hDC;
    aLogBrush: TLogBrush;
    aBrush: HBrush;
  Begin
    Case msg.lparamhi Of
      CTLCOLOR_DLG: 
          msg.result := GetStockObject( LTGRAY_BRUSH );
      CTLCOLOR_STATIC, CTLCOLOR_MSGBOX, CTLCOLOR_BTN: Begin
          aBrush := GetStockObject( LTGRAY_BRUSH );
          msg.result := aBrush;
          GetObject( aBrush, Sizeof( aLogBrush ), @aLogBrush );
          aDC := msg.wparam;
          SetBkColor( aDC, aLogBrush.lbColor );
          SetBkMode( aDC, OPAQUE );
        End
    Else
      DefWndProc( msg );
    End;
  End;

Procedure TGrayDlgWindow.WMCtlColor( Var Msg: TMessage );
  Var
    aDC: hDC;
  Begin
    Case msg.lparamhi Of
      CTLCOLOR_DLG:
          msg.result := GetStockObject( LTGRAY_BRUSH );
      CTLCOLOR_STATIC, CTLCOLOR_MSGBOX, CTLCOLOR_BTN: Begin
          msg.result := GetStockObject( LTGRAY_BRUSH );
          aDC := msg.wparam;
          SetBkColor( aDC, GetSysColor( COLOR_BTNFACE ));
          SetBkMode( aDC, OPAQUE );
        End
    Else
      DefWndProc( msg );
    End;
  End;

End.
